
% Figures Weak ENF
clear all; close all; clc
addpath('.\common')

filen = 'test_sig1'; cp=[535696 794768];
%filen = 'test_sig2'; cp=[441856 700160]; 
%filen = 'test_sig3'; cp=312195*[1 1];

screen_size = get(0, 'ScreenSize');
% Loads filter coefficients 
load filter_60Hz_1p4Hz_4th  % loads filter coeff. a and b (elliptic bandpass centered at 60 Hz)
load filter_PB20_20Hz_5th % b20 a20 (elliptic lowpass filter with 20Hz passband and zero at 60 Hz)

p1=150;
p2=60; % minimum duration of a utterance (in ms)
br=2000; % number of samples to be discarded in the beginning and end of the detection signals (due to trasnsients) 

TG=5;

[x,fs]=wavread(filen);   % reads wavfile
TT=(length(x)-4000*3675/100)./fs;
s60=fs/60;
fsd=1200;   % new sampling rate
cpt=cp/fs;
cpt=cpt-br/fsd;

xds=resample(x,100,3675,20); % downsampling from 44.1 Hz to 1200 Hz  

[vad_xds,ind0d,ind1d]=vad_v3(xds,fsd,p1,p2);
vad_xds=vad_xds(br:end-br-1);

xds_f=filtfilt(b,a,xds); % bandpass filters (around 60Hz) the downsampled signal 
z=hilbert(xds_f);  % calculates the analytic signal associated with xds_f
f=phase(z(2:end,:).*conj(z(1:end-1,:)));  % Hilbert estimate of the instantaneous frequency of xds_f  

xds=xds(br:end-br-1);

f=f-median(f(br:end-br));  % removes median value from the instananeous frequency of xds_f 
% Here we are interested in the variations of f 
f=filtfilt(b20,a20,f); % lowpass filters f (20Hz passband) to remove the 60 Hz oscillations that leaks into the Hilbert estimate

mf=abs(f); % takes the magnitude of the processed f
% mf should display moderate magnitude bumbs for unedited signals and high
% level peaks when editing (or strong saturation) occurs 
vm_f=tpswma_new2(mf,length(mf),600,150,2); % calculates a variable thrshold for mf via TPSW filtering 
f=f(br:end-br);

mf=mf(br:end-br); % removes boundary transients in mf 
vm_f=vm_f(br:end-br); % removes boundary transients in vm_f 

thr_mf=vm_f+TG*median(vm_f); % computes threshold for mf
% The threshold is contructed as vm_f plus an offset that lifts the whole variable threshold to 5.5
% times its median 
clear vm_f

mf_ht=(mf>=thr_mf).*mf; % hard-thresholded mf
idx_max_mf_ht = find((mf_ht(3:end) < mf_ht(2:end-1))&(mf_ht(1:end-2)<(mf_ht(2:end-1))))+1; % finds indices of local maxima of mf_ht
aux_mf_ht=zeros(size(mf_ht)); 
aux_mf_ht(idx_max_mf_ht)=1;
ind_mf=find(aux_mf_ht.*(~vad_xds)); % checks whether there are values of mf above thr_mf inside the voice-inactivity regions 

if ~isempty(ind_mf),  % if ind_mf is not empty 
    det_status='hit';
    %counter_hit=counter_hit+1;
else
    det_status='miss';
    %counter_miss=counter_miss+1;
end

subplot(311)
tb=(0:length(xds)-1)/fsd;
mmm=max(max(mf),max(thr_mf));
plot(tb,mf,'linewidth',2); hold on; plot(tb,mmm*vad_xds,'r','linewidth',2); % plots mf and thr_mf
plot(tb,thr_mf,'k','linewidth',2); plot((idx_max_mf_ht-1)./fsd,mf(idx_max_mf_ht),'ro','linewidth',2,'color',[0 0.6 0],'markersize',8)
plot([cpt(1) cpt(1)], [-0.2e-4 1.15*mmm],'k--','linewidth',2)
plot([cpt(2) cpt(2)], [-0.2e-4 1.15*mmm],'k--','linewidth',2)

set(gca,'fontsize',15)
%text(0.1,4.83e-4,'(a)','fontsize',15)
axis([0 TT -0.2e-4 1.15*mmm])
set(gcf, 'Position', [179   134   943   743] ); % 
xlabel('Time (s)')
ylabel('Frequency (rad/sample)')

%%%%%%%%%%%%%%%%%%%%
%filen = 'test_sig1'; cp=[535696 794768];
filen = 'test_sig2'; cp=[441856 700160]; 
%filen = 'test_sig3'; cp=312195*[1 1];

screen_size = get(0, 'ScreenSize');
% Loads filter coefficients 
load filter_60Hz_1p4Hz_4th  % loads filter coeff. a and b (elliptic bandpass centered at 60 Hz)
load filter_PB20_20Hz_5th % b20 a20 (elliptic lowpass filter with 20Hz passband and zero at 60 Hz)

p1=150;
p2=60; % minimum duration of a utterance (in ms)
br=2000; % number of samples to be discarded in the beginning and end of the detection signals (due to trasnsients) 

TG=5;

[x,fs]=wavread(filen);   % reads wavfile
TT=(length(x)-4000*3675/100)./fs;
s60=fs/60;
fsd=1200;   % new sampling rate
cpt=cp/fs;
cpt=cpt-br/fsd;

xds=resample(x,100,3675,20); % downsampling from 44.1 Hz to 1200 Hz  

[vad_xds,ind0d,ind1d]=vad_v3(xds,fsd,p1,p2);
vad_xds=vad_xds(br:end-br-1);

xds_f=filtfilt(b,a,xds); % bandpass filters (around 60Hz) the downsampled signal 
z=hilbert(xds_f);  % calculates the analytic signal associated with xds_f
f=phase(z(2:end,:).*conj(z(1:end-1,:)));  % Hilbert estimate of the instantaneous frequency of xds_f  

xds=xds(br:end-br-1);

f=f-median(f(br:end-br));  % removes median value from the instananeous frequency of xds_f 
% Here we are interested in the variations of f 
f=filtfilt(b20,a20,f); % lowpass filters f (20Hz passband) to remove the 60 Hz oscillations that leaks into the Hilbert estimate

mf=abs(f); % takes the magnitude of the processed f
% mf should display moderate magnitude bumbs for unedited signals and high
% level peaks when editing (or strong saturation) occurs 
vm_f=tpswma_new2(mf,length(mf),600,150,2); % calculates a variable thrshold for mf via TPSW filtering 
f=f(br:end-br);

mf=mf(br:end-br); % removes boundary transients in mf 
vm_f=vm_f(br:end-br); % removes boundary transients in vm_f 

thr_mf=vm_f+TG*median(vm_f); % computes threshold for mf
% The threshold is contructed as vm_f plus an offset that lifts the whole variable threshold to 5.5
% times its median 
clear vm_f

mf_ht=(mf>=thr_mf).*mf; % hard-thresholded mf
idx_max_mf_ht = find((mf_ht(3:end) < mf_ht(2:end-1))&(mf_ht(1:end-2)<(mf_ht(2:end-1))))+1; % finds indices of local maxima of mf_ht
aux_mf_ht=zeros(size(mf_ht)); 
aux_mf_ht(idx_max_mf_ht)=1;
ind_mf=find(aux_mf_ht.*(~vad_xds)); % checks whether there are values of mf above thr_mf inside the voice-inactivity regions 

if ~isempty(ind_mf),  % if ind_mf is not empty 
    det_status='hit';
    %counter_hit=counter_hit+1;
else
    det_status='miss';
    %counter_miss=counter_miss+1;
end

subplot(312)
tb=(0:length(xds)-1)/fsd;
mmm=max(max(mf),max(thr_mf));
plot(tb,mf,'linewidth',2); hold on; plot(tb,mmm*vad_xds,'r','linewidth',2); % plots mf and thr_mf
plot(tb,thr_mf,'k','linewidth',2); plot((idx_max_mf_ht-1)./fsd,mf(idx_max_mf_ht),'ro','linewidth',2,'color',[0 0.6 0],'markersize',8)
plot([cpt(1) cpt(1)], [-0.2e-4 1.15*mmm],'k--','linewidth',2)
plot([cpt(2) cpt(2)], [-0.2e-4 1.15*mmm],'k--','linewidth',2)

set(gca,'fontsize',15)
%text(0.1,4.83e-4,'(a)','fontsize',15)
axis([0 TT -0.2e-4 1.15*mmm])
set(gcf, 'Position', [179   134   943   743] ); % 
xlabel('Time (s)')
ylabel('Frequency (rad/sample)')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%filen = 'test_sig1'; cp=[535696 794768];
%filen = 'test_sig2'; cp=[441856 700160]; 
filen = 'test_sig3'; cp=312195*[1 1];

screen_size = get(0, 'ScreenSize');
% Loads filter coefficients 
load filter_60Hz_1p4Hz_4th  % loads filter coeff. a and b (elliptic bandpass centered at 60 Hz)
load filter_PB20_20Hz_5th % b20 a20 (elliptic lowpass filter with 20Hz passband and zero at 60 Hz)

p1=150;
p2=60; % minimum duration of a utterance (in ms)
br=2000; % number of samples to be discarded in the beginning and end of the detection signals (due to trasnsients) 

TG=5;

[x,fs]=wavread(filen);   % reads wavfile
TT=(length(x)-4000*3675/100)./fs;
s60=fs/60;
fsd=1200;   % new sampling rate
cpt=cp/fs;
cpt=cpt-br/fsd;

xds=resample(x,100,3675,20); % downsampling from 44.1 Hz to 1200 Hz  

[vad_xds,ind0d,ind1d]=vad_v3(xds,fsd,p1,p2);
vad_xds=vad_xds(br:end-br-1);

xds_f=filtfilt(b,a,xds); % bandpass filters (around 60Hz) the downsampled signal 
z=hilbert(xds_f);  % calculates the analytic signal associated with xds_f
f=phase(z(2:end,:).*conj(z(1:end-1,:)));  % Hilbert estimate of the instantaneous frequency of xds_f  

xds=xds(br:end-br-1);

f=f-median(f(br:end-br));  % removes median value from the instananeous frequency of xds_f 
% Here we are interested in the variations of f 
f=filtfilt(b20,a20,f); % lowpass filters f (20Hz passband) to remove the 60 Hz oscillations that leaks into the Hilbert estimate

mf=abs(f); % takes the magnitude of the processed f
% mf should display moderate magnitude bumbs for unedited signals and high
% level peaks when editing (or strong saturation) occurs 
vm_f=tpswma_new2(mf,length(mf),600,150,2); % calculates a variable thrshold for mf via TPSW filtering 
f=f(br:end-br);

mf=mf(br:end-br); % removes boundary transients in mf 
vm_f=vm_f(br:end-br); % removes boundary transients in vm_f 

thr_mf=vm_f+TG*median(vm_f); % computes threshold for mf
% The threshold is contructed as vm_f plus an offset that lifts the whole variable threshold to 5.5
% times its median 
clear vm_f

mf_ht=(mf>=thr_mf).*mf; % hard-thresholded mf
idx_max_mf_ht = find((mf_ht(3:end) < mf_ht(2:end-1))&(mf_ht(1:end-2)<(mf_ht(2:end-1))))+1; % finds indices of local maxima of mf_ht
aux_mf_ht=zeros(size(mf_ht)); 
aux_mf_ht(idx_max_mf_ht)=1;
ind_mf=find(aux_mf_ht.*(~vad_xds)); % checks whether there are values of mf above thr_mf inside the voice-inactivity regions 

if ~isempty(ind_mf),  % if ind_mf is not empty 
    det_status='hit';
    %counter_hit=counter_hit+1;
else
    det_status='miss';
    %counter_miss=counter_miss+1;
end

subplot(313)
tb=(0:length(xds)-1)/fsd;
mmm=max(max(mf),max(thr_mf));
plot(tb,mf,'linewidth',2); hold on; plot(tb,mmm*vad_xds,'r','linewidth',2); % plots mf and thr_mf
plot(tb,thr_mf,'k','linewidth',2); plot((idx_max_mf_ht-1)./fsd,mf(idx_max_mf_ht),'ro','linewidth',2,'color',[0 0.6 0],'markersize',8)
plot([cpt(1) cpt(1)], [-0.2e-4 1.15*mmm],'k--','linewidth',2)
plot([cpt(2) cpt(2)], [-0.2e-4 1.15*mmm],'k--','linewidth',2)

set(gca,'fontsize',15)
%text(0.1,4.83e-4,'(a)','fontsize',15)
axis([0 TT -0.2e-4 1.15*mmm])
set(gcf, 'Position', [179   134   943   743] ); % 
xlabel('Time (s)')
ylabel('Frequency (rad/sample)')

